/*Array.prototype.inArrayR = function (value)
{
    for (var i=0; i < this.length; i++) 
    {
        var regexp = convert2RegExp(this[i]);
        if(regexp)
        {
        	if(regexp.test(value))
        	{
        		return true;
        	}
        }
    }
    
    return false;
}*/
const urlBlockPrefBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.dlwatch.");

var dlwatchUrlBlock = 
{
	showBlockWarning: function(event)
	{
		event.target.location.href = "chrome://dlwatch/content/blockedError.xhtml";
	},
	
	checkArrayR: function(arr, value)
	{	var skip = false;
		for (var i=0; i < arr.length; i++) 
		{       skip = false;
			
			
			var regexp = convert2RegExp(arr[i]);
			if(regexp)
			{
				if(regexp.test(value))
				{
					
					//attempt to fix multiple window prompts
					tempAllowListArray = urlBlockPrefBranch.getCharPref("urlblocktempallow").split("|||");
					
					var templ;
					for(var p = 0;p<tempAllowListArray.length;p++){
					templ+=tempAllowListArray[p]+ " ";
					}
					d("tempList-" +templ);

					//found pattern and its white
                                        if(!this.isBlackList(urlBlockPrefBranch)){
					//alert('should allow - white found');
					return false;

					}

					//found pattern and its black

                			//compare against temporary allowed sites
                			for(var x=0;x<tempAllowListArray.length;x++){
						d(i + " looking for "+arr[i] + " " + tempAllowListArray[x] + " have " + value + " skip-" + skip);
                				if(arr[i] == tempAllowListArray[x]){

               					skip = true;
						d("found bad URL in safelist     allow-"+skip + " tittle-" +document.title);
                				return false;
                				}
						else{
						//d("not found skip-"+skip);
						}
                			}
					if(skip) return false;//break;
					//d("asking password, " + arr[i] + " value " + value );
                			if(skip == false && !dlwatch_authenticate_url(value)){
					return true;
					}	
					else{
						dlwatchUrlBlockPrefs.storeTempAllowList(arr[i]);
						return false;
					}
					
				}
			}
		}


		//did not find pattern and its white
		//should block

		if(!this.isBlackList(urlBlockPrefBranch)){
		        //return true;
           		
			
			if(!dlwatch_authenticate_url(value)){
		        	return true;
			}
			else{
			
			return false;
			}
			
		}		
		else{
		//did not find pattern and its black
		return false;
		}
	},

	showPrefs: function(notification, description)
	{
		window.open("chrome://dlwatch/content/options.xul", "Public Fox options", "chrome,centerscreen,resizable=no");
	},	
	
	showBlockWarningBar: function()
	{
		//var messageBarText = document.getElementById("blocksite.locale").getString("BlockSite.messageBarText");
		
		/*if(messageBarText == "")*/
			var messageBarText = "This website, or elements thereof, are on the Public Fox's blacklist and have not been loaded.";
                
                var notificationBox = gBrowser.getNotificationBox();
		var notification = notificationBox.getNotificationWithValue("website-blocked");
				
		/*var optionsButton;
		optionsButton.accesskey = null;
		optionsButton.callback = BlockSite.showPrefs;
		optionsButton.label = document.getElementById("blocksite.locale").getString("BlockSite.optionsButton");
		optionsButton.popup = null;
		var buttons = new Array();
		buttons.push(optionsButton);*/
		
		if(notification)
		{
			notification.label = messageBarText;
		}
		else
		{
			const priority = notificationBox.PRIORITY_WARNING_MEDIUM;
			//notificationBox.appendNotification(messageBarText, "website-blocked", "chrome://browser/skin/Info.png", priority, buttons);
			notificationBox.appendNotification(messageBarText, "website-blocked", "chrome://browser/skin/Info.png", priority, null);
		}
	},
	
	isBlackList: function(prefBranch)
	{
		if (!prefBranch.prefHasUserValue("urlblocklisttype"))
			return true;
		return prefBranch.getCharPref("urlblocklisttype") == "blacklistRadio";
	},
	
	checkLocation: function(location)
	{

		
		if(urlBlockPrefBranch.prefHasUserValue("urlblocklocations"))
		{
			var blockedLocationsString = urlBlockPrefBranch.getComplexValue("urlblocklocations", Components.interfaces.nsISupportsString).data;
			if(blockedLocationsString != "")
			{
				var blockedLocationsArray = blockedLocationsString.split("|||");
				
				//if(blockedLocationsArray.inArrayR(location))
				//if(this.checkArrayR(blockedLocationsArray, location))
				//	return this.isBlackList(urlBlockPrefBranch);
				return this.checkArrayR(blockedLocationsArray,location)
			}
		}
		
		return !this.isBlackList(urlBlockPrefBranch);
	},
	
	checkAnchor: function(anchor)
	{
		
		if(urlBlockPrefBranch.prefHasUserValue("urlblocklocations"))
		{
			var blockedLocationsString = urlBlockPrefBranch.getComplexValue("urlblocklocations", Components.interfaces.nsISupportsString).data;
			if(blockedLocationsString != "")
			{
				var blockedLocationsArray = blockedLocationsString.split("|||");
				
				//if(blockedLocationsArray.inArrayR(anchor.href))
				//if(this.checkArrayR(blockedLocationsArray, anchor.href))
				//	return this.isBlackList(urlBlockPrefBranch);
				return this.checkArrayR(blockedLocationsArray,anchor.href);
			}
		}
		
		return !this.isBlackList(urlBlockPrefBranch);
	},
	
	processAnchors: function(event)
	{
		var anchorElements = event.target.getElementsByTagName("a");
			
		for(var i=0; i < anchorElements.length; i++)
		{
			if(dlwatchUrlBlock.checkAnchor(anchorElements[i]))
			{
				var tempFragment = document.createDocumentFragment();
				var childNodes = anchorElements[i].childNodes;
				var parentNode = anchorElements[i].parentNode;
				
				for(var j=0; j < childNodes.length; j++)
				{
					tempFragment.appendChild(childNodes[j].cloneNode(true));
				}
				
				parentNode.replaceChild(tempFragment, anchorElements[i]);
				i--; //List is live, so replacing the node means that anchorElements[i] is refering to the next node already
			}
		}
	},
	
	processLocations: function(event)
	{
		if(event.type == "DOMContentLoaded")
		{
			if(dlwatchUrlBlock.checkLocation(event.target.location.href))
			{
				dlwatchUrlBlock.showBlockWarning(event);
			}
		}
		else if(event.type == "change")
		{
			if(dlwatchUrlBlock.checkLocation(gURLBar.value))
			{
				dlwatchUrlBlock.showBlockWarning(event);
			}
		}
	},
	processfileresource: function(event)
        {
		if(event.type == "DOMContentLoaded")
			var locatmp = event.target.location.href;
		else if(event.type == "change")
			var locatmp = gURLBar.value;
		if (locatmp.match(/^file:/) || 
		    locatmp.match(/^\//) || 
		    locatmp.match(/^chrome:/) ||
		    locatmp.match(/^resource:/) ||
		    (!locatmp.match(/^about:blank/) &&
		    locatmp.match(/^about:/))) {
		    loadURI("about:blank");
		}
	},
	dlwatchUrlBlockMain: function(event)
	{
		
		if(urlBlockPrefBranch.prefHasUserValue("urlblockenabled") && urlBlockPrefBranch.getBoolPref("urlblockenabled"))
		{			
			if(event.type === "DOMContentLoaded" || event.type == "change")
			{
				// Locations
				//dlwatchUrlBlock.processLocations(event);
				dlwatchUrlBlock.processfileresource(event);
				if(urlBlockPrefBranch.prefHasUserValue("blocklinks") && urlBlockPrefBranch.getBoolPref("blocklinks"))
				{
					// Anchors
					dlwatchUrlBlock.processAnchors(event);
				}



				urlBlockPrefBranch.setBoolPref("authlastreturn",false);
			}
		}
	}
}

// Event listener
window.document.getElementById("appcontent").addEventListener("DOMContentLoaded", dlwatchUrlBlock.dlwatchUrlBlockMain, false);
//gURLBar.addEventListener("change", BlockSite.BlockSiteMain, false);

// Observer for HTTP requests to block the sites we don't want
var observer = 
{
	observe: function(aSubject, aTopic, aData)
	{
		//alert(aSubject + "\n\n" + aTopic + "\n\n" + aData);
		if (aTopic != 'http-on-modify-request')
			return;

		aSubject.QueryInterface(Components.interfaces.nsIHttpChannel);
		
		
		if(urlBlockPrefBranch.prefHasUserValue("urlblockenabled") && urlBlockPrefBranch.getBoolPref("urlblockenabled"))
		{
			if (dlwatchUrlBlock.checkLocation(aSubject.URI.spec))
			{
				
                                dlwatchUrlBlock.showBlockWarningBar();
				aSubject.loadFlags = Components.interfaces.nsICachingChannel.LOAD_ONLY_FROM_CACHE;
				aSubject.cancel(Components.results.NS_ERROR_FAILURE);
				
			}
		}
	},

	QueryInterface: function(iid)
	{
		if (!iid.equals(Components.interfaces.nsISupports) &&
		!iid.equals(Components.interfaces.nsIObserver))
		throw Components.results.NS_ERROR_NO_INTERFACE;

		return this;
	}
};

// Add our observer
var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
observerService.addObserver(observer, "http-on-modify-request", false);

// Remove observer when current window closes
window.addEventListener("unload", function() {
  observerService.removeObserver(observer, "http-on-modify-request");
}, false);
